import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Vector;

import static java.lang.String.*;

/**
 *
 * @author Hofit Elimelech and Mor Shahak
 */

public class Data {
    public static final int NUM_RESULTS = 20;
	
    private String rec_db;
    private String shapiro;
    private double target_dg;
    private double dg;
    private ArrayList<Ans> best_ans;
    private double desiredNeut;
    private NucData nuc_input = null;
    private String init_seq;

    public Data(){
        this.best_ans = new ArrayList<Ans>(); 
    }

    public void setNucData(NucData data) throws InvalidNucleotideInputException
    {
	if (data.getNucStartLocation() >= rec_db.length())
		throw new InvalidNucleotideInputException("Illegal input sequence location");
	this.nuc_input = data;	
    }

    public NucData getNucData(){
	return this.nuc_input;
    }

    public void setInitSeq(String in) throws InvalidNucleotideInputException
    {
	if (in.length() != rec_db.length())
		throw new InvalidNucleotideInputException("Illegal length of initial sequence");
	this.init_seq = in;	
    }

    public String getInitSeq(){
	return this.init_seq;
    }
	
    public void setDesiredNeut(double des){
        this.desiredNeut=des;
    }

    public void setDG(double in){
        this.dg=in;
    }

    public void setTargetDG(double in){
        this.target_dg=in;
    }

    public void setShapiro(String in){
        this.shapiro=in;
    }

    public void setRecDB(String in){
        this.rec_db=in;
    }

    public String getRecDB(){
        return this.rec_db;
    }

    public String getShapiro(){
        return this.shapiro;
    }

    public double getTarget(){
        return this.target_dg;
    }

    public double getDG(){
        return this.dg;
    }

    public double getNeutrality(){
        return this.desiredNeut;
    }

    public ArrayList<Ans> getBestAns(){
        return this.best_ans;
    }

    public void addToAnsVec(Ans toAdd){
        this.best_ans.add(toAdd);
        Collections.sort(best_ans, new java.util.Comparator<Ans>() {
            @Override
            public int compare(Ans o1, Ans o2) {
                return o1.dist - o2.dist;
            }
        });
    }

    public String toString(){
        return MessageFormat.format("DG: {0}\nrec_db {1}\nshapiro {2}\ntarget dg {3}\nbestAns : {4}\nnuc : {5}\ninit_seq: {6}\n",
                valueOf(dg), this.rec_db, this.shapiro, valueOf(this.target_dg), this.best_ans.toString(),
		(this.nuc_input != null) ? this.nuc_input.toString() : "null",
		!this.init_seq.isEmpty() ? this.init_seq : "" );
    }
}
