import java.io.*;
import javax.swing.JFrame;
import java.awt.Dimension;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SwingConstants;
import java.text.*;
import java.util.*;

/*the class represents the first results window containing the initial data and the best ans*/
public class ResultFrame extends JFrame implements SwingConstants, java.awt.event.ActionListener{

    private Data data;
    private int counter;
    private JButton[] sequences;
    private JLabel[] labels;

    public ResultFrame(Data dat, int resetCounter) {
	// System.out.println(dat.toString());
        this.data = dat;
        this.counter = resetCounter;
        sequences = new JButton[this.data.getBestAns().size()];
        labels = new JLabel[this.data.getBestAns().size()];
    }

    public void actionPerformed(java.awt.event.ActionEvent evt) {
        try {
            for (int i = 0; i < this.data.getBestAns().size(); i++)
            {       
                if (evt.getSource() == sequences[i])
                    seq1Action(evt, i);
            }
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    public void init(){
        DecimalFormat df = new DecimalFormat("0.00");

        JFrame startResult = new JFrame ();//box for Clustering Resolution
        startResult.setSize(700, 1000);
        JPanel p=new JPanel();
        JPanel arguments = new JPanel(  );
        arguments.setLayout( new BoxLayout( arguments, BoxLayout.PAGE_AXIS ) );

        arguments.setPreferredSize( new Dimension( 1300 ,1000 ) );

        /*setting the results as a lables*/
        JLabel j_0 = new JLabel("                         ");
        JLabel j_00 = new JLabel("                         ");
        JLabel j_1 = new JLabel(" Supplied dot-bracket representation: " + data.getRecDB());
        JLabel j_11 = new JLabel("                         ");
        JLabel j_2 = new JLabel(" Target Shapiro: "+ data.getShapiro());
        JLabel j_22 = new JLabel("                         ");
        JLabel j_3 = new JLabel(" Target free energy: "+ ((data.getTarget() == -1000.0) ? 
				"no target" : df.format(data.getTarget())+" kcal/mol"));
        JLabel j_31 = new JLabel(" Target neutrality: "+ ((data.getNeutrality() == -1000.0) ? 
				"no target" : df.format(data.getNeutrality())));
        JLabel j_33 = new JLabel("                         ");
	JLabel j_4 = new JLabel(" Initial sequence: " + data.getInitSeq());
        JLabel j_44 = new JLabel("                         ");
        JLabel j_5 = new JLabel(" Best Answers: (press the buttons to view the secondary structure)");
        JLabel j_55 = new JLabel("                         ");

        arguments.add( j_00);
        arguments.add( j_1 );
        arguments.add( j_2 );
        arguments.add( j_3 );
        arguments.add(j_31);
        arguments.add( j_4);
        arguments.add( j_44);
        arguments.add( j_5 );
        arguments.add( j_55);

        for (int i = 0; i < this.data.getBestAns().size(); i++)
        {
            labels[i] = new JLabel(data.getBestAns().get(i).seq + "   Dot-bracket distance: " + data.getBestAns().get(i).dist);
            sequences[i] = new JButton();
            sequences[i].setText(MessageFormat.format("Sequence{0}", i + 1));
            arguments.add(labels[i]);
            arguments.add(sequences[i]);
            sequences[i].addActionListener(this);
        }

        JScrollPane scroll = new JScrollPane(arguments);

        startResult.getContentPane().add(scroll);

        /* arranging the frame*/
        startResult.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

        startResult.setTitle("20 Different Possible Sequences");
        startResult.setVisible(true);
        //      startResult.pack();
        if(!startResult.isShowing()){
            startResult.dispose();
        }
    }

    private void seq1Action(java.awt.event.ActionEvent event, int index) throws IOException
    {
        SequenceResult seqRes = new SequenceResult(this.data ,counter);
        try
        {
            seqRes.init(data.getBestAns().get(index), index);
        }
        catch (Exception e) {
        }

        seqRes.showFrame(index);
    }
}
