/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
*/

import java.awt.image.BufferedImage;
import java.text.DecimalFormat;
import java.text.MessageFormat;
import java.util.*;
import java.io.*;
import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.JFrame;


/**
 *
 * @author Hofit Elimelech and Mor Shahak
 *
 */
public class RunRNAfbinv extends javax.swing.JFrame implements java.awt.event.WindowListener
{
    private javax.swing.JButton fragmentButton;
    private javax.swing.JButton processButton;
    private javax.swing.JButton resetButton;
    private javax.swing.JButton headButton;
    private javax.swing.JLabel headLabel;
    private javax.swing.JTextArea inputTextArea;
    private javax.swing.JScrollPane inputScrollPane;
    private Data dat;
    private FragmentParser motifsParser;

    /**
     * @param args the command line arguments
     */

    public void init() throws IOException, InterruptedException{
        this.dat = new Data();
        this.motifsParser = null;
	boolean status = new File("tmp").mkdir();
        initComponents();
        inputTextArea.setFont(new java.awt.Font("Monospaced",java.awt.Font.PLAIN, 14));
        setSize(500,400);
    }

    public void windowClosed(java.awt.event.WindowEvent arg0) {
        // System.out.println("Window close event occur");
    }
    public void windowActivated(java.awt.event.WindowEvent arg0) {
        // System.out.println("Window Activated");
    }
    public void windowClosing(java.awt.event.WindowEvent arg0) {
        // System.out.println("Window Closing");
        try 
	{
	    delete(new File("tmp"));
        } 
	catch (IOException e) {
            e.printStackTrace();
	}
    }
    public void windowDeactivated(java.awt.event.WindowEvent arg0) {
        // System.out.println("Window Deactivated");
    }
    public void windowDeiconified(java.awt.event.WindowEvent arg0) {
        // System.out.println("Window Deiconified");
    }
    public void windowIconified(java.awt.event.WindowEvent arg0) {
        // System.out.println("Window Iconified");
    }
    public void windowOpened(java.awt.event.WindowEvent arg0) {
        // System.out.println("Window Opened");
    }
    private void delete(File f) throws IOException {
	if (f.isDirectory()) 
	{
    	     for (File c : f.listFiles())
      	     	delete(c);
	}
	if (!f.delete())
	    throw new IOException("Failed to delete file: " + f);
    }
    private void initComponents() {
        addWindowListener(this);
        java.awt.GridBagConstraints gridBagConstraints;
        getContentPane().setLayout(new java.awt.GridBagLayout());

        /* creating the buttons   */
        fragmentButton = new javax.swing.JButton();
        processButton = new javax.swing.JButton();
	resetButton = new javax.swing.JButton(); 
        inputScrollPane = new javax.swing.JScrollPane();
        headButton = new javax.swing.JButton();
        headLabel = new javax.swing.JLabel("Please insert your structure (Dot Bracket)");

        /* setting the text in the buttons */
        fragmentButton.setText("Fragment");
        processButton.setText("Process");
	resetButton.setText("Reset");
        headButton.setText("Please insert your structure (Dot Bracket)");
        headLabel.setFont(new java.awt.Font("Times New Roman", java.awt.Font.BOLD, 14));

        fragmentButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fragmentAction(evt);
            }
        });

        processButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                processAction(evt);
            }
        });

        resetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetAction(evt);
            }
        });

        /* defining the input area */
        inputTextArea = new javax.swing.JTextArea();
        inputTextArea.setColumns(20);
        inputTextArea.setMargin(new java.awt.Insets(4, 4, 4, 4));
        inputScrollPane.setViewportView(inputTextArea);

        /*defining the panel constraints */

        /*head button*/
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.ipadx = 25;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 12);
        getContentPane().add(headLabel, gridBagConstraints);

        /*head button*/
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridheight = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(4, 6, 12, 6);
        getContentPane().add(inputScrollPane, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.ipadx = 12;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 12);
        getContentPane().add(fragmentButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 25;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 12);
        getContentPane().add(processButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.ipadx = 40;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 12);
        getContentPane().add(resetButton, gridBagConstraints);
    }

    private void processAction(java.awt.event.ActionEvent event){
        ProcessFrame res = new ProcessFrame();
        if (this.motifsParser != null)
        {
	    if (this.motifsParser.getSelectedMotif() != null)
            	// System.out.println(this.motifsParser.getSelectedMotif().toString());
            res.init(this.dat.getRecDB(), this.motifsParser.getSelectedMotif());
        }
        else
        {
            res.init(this.dat.getRecDB(), null);
        }
        res.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        res.setTitle("RNAfbinv");
        res.setVisible(true);
    }

    private void fragmentAction(java.awt.event.ActionEvent event){
        this.dat = new Data();

        String dotBracket = (inputTextArea.getText()).trim();
        if (!isBalanced(dotBracket))
        {
            ErrorFrame err = new ErrorFrame();
            err.init();
	    return;
        }

	inputTextArea.setEnabled(false);
	this.dat.setRecDB(dotBracket);
	try
	{
	RNAshapiroParser parser = new RNAshapiroParser();
	this.dat.setShapiro(parser.GetShapiro(this.dat.getRecDB()));
	this.motifsParser = new FragmentParser(this.dat.getShapiro());
	Utils.createWildTypePlot(this.dat.getRecDB());
	showFrame();
	}
	catch (Exception e){
	System.out.println(e);
	}
    }

    private void resetAction(java.awt.event.ActionEvent event){
        this.dat = new Data();
        inputTextArea.setText("");
        inputTextArea.setEnabled(true);
    }

    private boolean isBalanced (String brack){
        int left = 0; int right= 0;

        if(brack.length()<1){
            return false;
        }
        for (int i = 0; i < brack.length(); i++) {
            if  (brack.charAt(i) == '('){
                left++;
            }
            else if (brack.charAt(i) == ')') {
                right++;
            }
            else if (brack.charAt(i) != '.'){
                return false;
            }
            if (right > left){
                return false;
            }
            if (i == (brack.length()-1)){
                return (left == right);
            }
        }
        return true;
    }

    public void showFrame() throws IOException
    {
        DecimalFormat df = new DecimalFormat("0.00");

        /*creating a frame*/
        JFrame seq  = new JFrame (); //box for Clustering Resolution
        seq.setSize(500,700);

        JComboBox elementList = new JComboBox();

	// this.motifsParser.printMotifs();
        for (Map.Entry<Integer, MotifData> entry : this.motifsParser.getMotifs().entrySet())
        {
            MotifData motif = (MotifData)entry.getValue();
            elementList.addItem(motif);
        }        

        elementList.addActionListener(this.motifsParser);
        elementList.setSelectedIndex(0);

        JPanel elementPanel = new JPanel();
        elementPanel.add(elementList);

        java.awt.GridBagConstraints gridBagConstraints;
        seq.getContentPane().setLayout(new java.awt.GridBagLayout());

        JLabel shapiroLabel = new JLabel("Shapiro representation: "+ this.dat.getShapiro());

        JLabel targetLabel = new JLabel("Target:  ");
        JPanel argumentsTitles1 = new JPanel(  );
        argumentsTitles1.add(targetLabel);

        BufferedImage wildIcon = ImageIO.read(new File("tmp/rnaWild.jpeg"));
	wildIcon = wildIcon.getSubimage(69,195,452,452);
        JLabel labWild = new JLabel(new ImageIcon(wildIcon));
        JPanel wildArguments = new JPanel(  );
        wildArguments.add(labWild);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        seq.getContentPane().add(argumentsTitles1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        seq.getContentPane().add(wildArguments, gridBagConstraints);

        JPanel arguments = new JPanel(  );
        JLabel lab0 = new JLabel("   ");
        arguments.add(lab0);
        arguments.add(lab0);
        arguments.add(shapiroLabel);
        arguments.add(elementList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 20;
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.ipadx = 60;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        seq.getContentPane().add(arguments, gridBagConstraints);

        arguments.setLayout( new BoxLayout( arguments, BoxLayout.PAGE_AXIS ) );
        arguments.setBorder( BorderFactory.createCompoundBorder(
                BorderFactory.createTitledBorder( "Structure data" ),
                BorderFactory.createEmptyBorder( 5, 5, 5, 5 ) ) );

        seq.getContentPane().add(elementPanel);

        /* arranging the frame*/
        seq.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

        seq.setTitle("The fragments of the structure");
        seq.setVisible(true);
        if(!seq.isDisplayable())
        {
            seq.dispose();
        }
    }

    public static void main(String[] args) {
        try {
            RunRNAfbinv frame = new RunRNAfbinv();
            frame.init();
            frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
            frame.setTitle("RNAfbinv");
            frame.setVisible(true);
        }
        catch (Exception e){
            System.out.println(e);
        }
    }
}
